//
// OnvifAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation
import Alamofire


open class OnvifAPI {
    /**
     Get camera image information

     - parameter cameraId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getCameraImageInfo(cameraId: UUID, completion: @escaping ((_ data: ONVIFCameraImageInfo?,_ error: Error?) -> Void)) {
        getCameraImageInfoWithRequestBuilder(cameraId: cameraId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get camera image information
     - GET /api/v1/onvif/{camera_id}/image

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "brightness" : {
    "supported_range" : {
      "max_val" : 7.061401241503109,
      "min_val" : 2.3021358869347655
    },
    "current_value" : 0.8008281904610115
  },
  "exposure" : { },
  "backlight_compensation" : {
    "supported_modes" : [ null, null ],
    "current_mode" : "ON"
  },
  "white_balance" : {
    "supported_modes" : [ null, null ],
    "current_mode" : "AUTO",
    "supported_range" : { },
    "current_cr_gain_value" : 6.027456183070403,
    "current_cb_gain_value" : 1.4658129805029452
  },
  "ir_cut_filter" : {
    "supported_modes" : [ null, null ],
    "current_mode" : "ON"
  },
  "wide_dynamic_range" : {
    "supported_modes" : [ null, null ],
    "current_mode" : "ON",
    "current_value" : 5.962133916683182
  }
}}]
     - parameter cameraId: (path)  

     - returns: RequestBuilder<ONVIFCameraImageInfo> 
     */
    open class func getCameraImageInfoWithRequestBuilder(cameraId: UUID) -> RequestBuilder<ONVIFCameraImageInfo> {
        var path = "/api/v1/onvif/{camera_id}/image"
        let cameraIdPreEscape = "\(cameraId)"
        let cameraIdPostEscape = cameraIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{camera_id}", with: cameraIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<ONVIFCameraImageInfo>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Get camera information

     - parameter cameraId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getCameraInfo(cameraId: UUID, completion: @escaping ((_ data: ONVIFCameraInfo?,_ error: Error?) -> Void)) {
        getCameraInfoWithRequestBuilder(cameraId: cameraId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get camera information
     - GET /api/v1/onvif/{camera_id}

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "model" : "model",
  "serial_number" : "serial_number",
  "firmware_version" : "firmware_version",
  "hardware_id" : "hardware_id",
  "manufacturer" : "manufacturer"
}}]
     - parameter cameraId: (path)  

     - returns: RequestBuilder<ONVIFCameraInfo> 
     */
    open class func getCameraInfoWithRequestBuilder(cameraId: UUID) -> RequestBuilder<ONVIFCameraInfo> {
        var path = "/api/v1/onvif/{camera_id}"
        let cameraIdPreEscape = "\(cameraId)"
        let cameraIdPostEscape = cameraIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{camera_id}", with: cameraIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<ONVIFCameraInfo>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Get camera network settings

     - parameter cameraId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getCameraNetworkSettings(cameraId: UUID, completion: @escaping ((_ data: ONVIFCameraNetworkSettingsGet?,_ error: Error?) -> Void)) {
        getCameraNetworkSettingsWithRequestBuilder(cameraId: cameraId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get camera network settings
     - GET /api/v1/onvif/{camera_id}/network

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "http" : {
    "port" : 0,
    "enabled" : true
  }
}}]
     - parameter cameraId: (path)  

     - returns: RequestBuilder<ONVIFCameraNetworkSettingsGet> 
     */
    open class func getCameraNetworkSettingsWithRequestBuilder(cameraId: UUID) -> RequestBuilder<ONVIFCameraNetworkSettingsGet> {
        var path = "/api/v1/onvif/{camera_id}/network"
        let cameraIdPreEscape = "\(cameraId)"
        let cameraIdPostEscape = cameraIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{camera_id}", with: cameraIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<ONVIFCameraNetworkSettingsGet>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Get camera PTZ

     - parameter cameraId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getCameraPtz(cameraId: UUID, completion: @escaping ((_ data: ONVIFCameraPTZInfo?,_ error: Error?) -> Void)) {
        getCameraPtzWithRequestBuilder(cameraId: cameraId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get camera PTZ
     - GET /api/v1/onvif/{camera_id}/ptz

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "pan_tilt" : {
    "supported_range" : {
      "x" : {
        "max_val" : 7.061401241503109,
        "min_val" : 2.3021358869347655
      }
    },
    "current_position" : {
      "x" : 0.8008281904610115,
      "y" : 6.027456183070403
    }
  },
  "zoom" : {
    "default_speed_value" : 1.4658129805029452
  }
}}]
     - parameter cameraId: (path)  

     - returns: RequestBuilder<ONVIFCameraPTZInfo> 
     */
    open class func getCameraPtzWithRequestBuilder(cameraId: UUID) -> RequestBuilder<ONVIFCameraPTZInfo> {
        var path = "/api/v1/onvif/{camera_id}/ptz"
        let cameraIdPreEscape = "\(cameraId)"
        let cameraIdPostEscape = cameraIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{camera_id}", with: cameraIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<ONVIFCameraPTZInfo>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Get camera streams information

     - parameter cameraId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getCameraStreamsInfo(cameraId: UUID, completion: @escaping ((_ data: ONVIFCameraStreamsInfo?,_ error: Error?) -> Void)) {
        getCameraStreamsInfoWithRequestBuilder(cameraId: cameraId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get camera streams information
     - GET /api/v1/onvif/{camera_id}/streams

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "streams" : [ {
    "current_resolution" : "320x240",
    "supported_encoders" : [ {
      "name" : "name",
      "supported_resolutions" : [ {
        "width" : 5,
        "height" : 5
      }, {
        "width" : 5,
        "height" : 5
      } ],
      "framerate_range" : {
        "max_val" : 7.061401241503109,
        "min_val" : 2.3021358869347655
      }
    }, {
      "name" : "name",
      "supported_resolutions" : [ {
        "width" : 5,
        "height" : 5
      }, {
        "width" : 5,
        "height" : 5
      } ],
      "framerate_range" : {
        "max_val" : 7.061401241503109,
        "min_val" : 2.3021358869347655
      }
    } ],
    "name" : "name",
    "link" : "http://example.com/aeiou",
    "current_bitrate" : 6,
    "current_encoder" : "H264",
    "current_gov_length" : 1,
    "current_framerate" : 0
  }, {
    "current_resolution" : "320x240",
    "supported_encoders" : [ {
      "name" : "name",
      "supported_resolutions" : [ {
        "width" : 5,
        "height" : 5
      }, {
        "width" : 5,
        "height" : 5
      } ],
      "framerate_range" : {
        "max_val" : 7.061401241503109,
        "min_val" : 2.3021358869347655
      }
    }, {
      "name" : "name",
      "supported_resolutions" : [ {
        "width" : 5,
        "height" : 5
      }, {
        "width" : 5,
        "height" : 5
      } ],
      "framerate_range" : {
        "max_val" : 7.061401241503109,
        "min_val" : 2.3021358869347655
      }
    } ],
    "name" : "name",
    "link" : "http://example.com/aeiou",
    "current_bitrate" : 6,
    "current_encoder" : "H264",
    "current_gov_length" : 1,
    "current_framerate" : 0
  } ]
}}]
     - parameter cameraId: (path)  

     - returns: RequestBuilder<ONVIFCameraStreamsInfo> 
     */
    open class func getCameraStreamsInfoWithRequestBuilder(cameraId: UUID) -> RequestBuilder<ONVIFCameraStreamsInfo> {
        var path = "/api/v1/onvif/{camera_id}/streams"
        let cameraIdPreEscape = "\(cameraId)"
        let cameraIdPostEscape = cameraIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{camera_id}", with: cameraIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<ONVIFCameraStreamsInfo>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Get camera users information

     - parameter cameraId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getCameraUsers(cameraId: UUID, completion: @escaping ((_ data: ONVIFCameraUsersInfoGet?,_ error: Error?) -> Void)) {
        getCameraUsersWithRequestBuilder(cameraId: cameraId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get camera users information
     - GET /api/v1/onvif/{camera_id}/users

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "users" : [ {
    "user_name" : "user_name",
    "user_level" : "user_level"
  }, {
    "user_name" : "user_name",
    "user_level" : "user_level"
  } ]
}}]
     - parameter cameraId: (path)  

     - returns: RequestBuilder<ONVIFCameraUsersInfoGet> 
     */
    open class func getCameraUsersWithRequestBuilder(cameraId: UUID) -> RequestBuilder<ONVIFCameraUsersInfoGet> {
        var path = "/api/v1/onvif/{camera_id}/users"
        let cameraIdPreEscape = "\(cameraId)"
        let cameraIdPostEscape = cameraIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{camera_id}", with: cameraIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<ONVIFCameraUsersInfoGet>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Update camera image backlight compensation

     - parameter body: (body)  
     - parameter cameraId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func updateCameraImageBacklightCompensation(body: ONVIFCameraBacklightUpdate, cameraId: UUID, completion: @escaping ((_ data: APIResponseStatusOK?,_ error: Error?) -> Void)) {
        updateCameraImageBacklightCompensationWithRequestBuilder(body: body, cameraId: cameraId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Update camera image backlight compensation
     - PUT /api/v1/onvif/{camera_id}/image/backlight

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "status" : "ok"
}}]
     - parameter body: (body)  
     - parameter cameraId: (path)  

     - returns: RequestBuilder<APIResponseStatusOK> 
     */
    open class func updateCameraImageBacklightCompensationWithRequestBuilder(body: ONVIFCameraBacklightUpdate, cameraId: UUID) -> RequestBuilder<APIResponseStatusOK> {
        var path = "/api/v1/onvif/{camera_id}/image/backlight"
        let cameraIdPreEscape = "\(cameraId)"
        let cameraIdPostEscape = cameraIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{camera_id}", with: cameraIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<APIResponseStatusOK>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "PUT", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
    /**
     Update camera image brightness

     - parameter body: (body)  
     - parameter cameraId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func updateCameraImageBrightness(body: ONVIFCameraImageSettingUpdate, cameraId: UUID, completion: @escaping ((_ data: APIResponseStatusOK?,_ error: Error?) -> Void)) {
        updateCameraImageBrightnessWithRequestBuilder(body: body, cameraId: cameraId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Update camera image brightness
     - PUT /api/v1/onvif/{camera_id}/image/brightness

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "status" : "ok"
}}]
     - parameter body: (body)  
     - parameter cameraId: (path)  

     - returns: RequestBuilder<APIResponseStatusOK> 
     */
    open class func updateCameraImageBrightnessWithRequestBuilder(body: ONVIFCameraImageSettingUpdate, cameraId: UUID) -> RequestBuilder<APIResponseStatusOK> {
        var path = "/api/v1/onvif/{camera_id}/image/brightness"
        let cameraIdPreEscape = "\(cameraId)"
        let cameraIdPostEscape = cameraIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{camera_id}", with: cameraIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<APIResponseStatusOK>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "PUT", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
    /**
     Update camera image color saturation

     - parameter body: (body)  
     - parameter cameraId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func updateCameraImageColorSaturation(body: ONVIFCameraImageSettingUpdate, cameraId: UUID, completion: @escaping ((_ data: APIResponseStatusOK?,_ error: Error?) -> Void)) {
        updateCameraImageColorSaturationWithRequestBuilder(body: body, cameraId: cameraId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Update camera image color saturation
     - PUT /api/v1/onvif/{camera_id}/image/saturation

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "status" : "ok"
}}]
     - parameter body: (body)  
     - parameter cameraId: (path)  

     - returns: RequestBuilder<APIResponseStatusOK> 
     */
    open class func updateCameraImageColorSaturationWithRequestBuilder(body: ONVIFCameraImageSettingUpdate, cameraId: UUID) -> RequestBuilder<APIResponseStatusOK> {
        var path = "/api/v1/onvif/{camera_id}/image/saturation"
        let cameraIdPreEscape = "\(cameraId)"
        let cameraIdPostEscape = cameraIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{camera_id}", with: cameraIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<APIResponseStatusOK>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "PUT", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
    /**
     Update camera image contrast

     - parameter body: (body)  
     - parameter cameraId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func updateCameraImageContrast(body: ONVIFCameraImageSettingUpdate, cameraId: UUID, completion: @escaping ((_ data: APIResponseStatusOK?,_ error: Error?) -> Void)) {
        updateCameraImageContrastWithRequestBuilder(body: body, cameraId: cameraId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Update camera image contrast
     - PUT /api/v1/onvif/{camera_id}/image/contrast

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "status" : "ok"
}}]
     - parameter body: (body)  
     - parameter cameraId: (path)  

     - returns: RequestBuilder<APIResponseStatusOK> 
     */
    open class func updateCameraImageContrastWithRequestBuilder(body: ONVIFCameraImageSettingUpdate, cameraId: UUID) -> RequestBuilder<APIResponseStatusOK> {
        var path = "/api/v1/onvif/{camera_id}/image/contrast"
        let cameraIdPreEscape = "\(cameraId)"
        let cameraIdPostEscape = cameraIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{camera_id}", with: cameraIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<APIResponseStatusOK>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "PUT", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
    /**
     Update camera image exposure

     - parameter body: (body)  
     - parameter cameraId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func updateCameraImageExposure(body: ONVIFCameraExposureUpdate, cameraId: UUID, completion: @escaping ((_ data: APIResponseStatusOK?,_ error: Error?) -> Void)) {
        updateCameraImageExposureWithRequestBuilder(body: body, cameraId: cameraId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Update camera image exposure
     - PUT /api/v1/onvif/{camera_id}/image/exposure

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "status" : "ok"
}}]
     - parameter body: (body)  
     - parameter cameraId: (path)  

     - returns: RequestBuilder<APIResponseStatusOK> 
     */
    open class func updateCameraImageExposureWithRequestBuilder(body: ONVIFCameraExposureUpdate, cameraId: UUID) -> RequestBuilder<APIResponseStatusOK> {
        var path = "/api/v1/onvif/{camera_id}/image/exposure"
        let cameraIdPreEscape = "\(cameraId)"
        let cameraIdPostEscape = cameraIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{camera_id}", with: cameraIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<APIResponseStatusOK>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "PUT", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
    /**
     Update camera image IR cut filter

     - parameter body: (body)  
     - parameter cameraId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func updateCameraImageIrCutFilter(body: ONVIFCameraIrCutFilterUpdate, cameraId: UUID, completion: @escaping ((_ data: APIResponseStatusOK?,_ error: Error?) -> Void)) {
        updateCameraImageIrCutFilterWithRequestBuilder(body: body, cameraId: cameraId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Update camera image IR cut filter
     - PUT /api/v1/onvif/{camera_id}/image/ir

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "status" : "ok"
}}]
     - parameter body: (body)  
     - parameter cameraId: (path)  

     - returns: RequestBuilder<APIResponseStatusOK> 
     */
    open class func updateCameraImageIrCutFilterWithRequestBuilder(body: ONVIFCameraIrCutFilterUpdate, cameraId: UUID) -> RequestBuilder<APIResponseStatusOK> {
        var path = "/api/v1/onvif/{camera_id}/image/ir"
        let cameraIdPreEscape = "\(cameraId)"
        let cameraIdPostEscape = cameraIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{camera_id}", with: cameraIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<APIResponseStatusOK>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "PUT", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
    /**
     Update camera image sharpness

     - parameter body: (body)  
     - parameter cameraId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func updateCameraImageSharpness(body: ONVIFCameraImageSettingUpdate, cameraId: UUID, completion: @escaping ((_ data: APIResponseStatusOK?,_ error: Error?) -> Void)) {
        updateCameraImageSharpnessWithRequestBuilder(body: body, cameraId: cameraId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Update camera image sharpness
     - PUT /api/v1/onvif/{camera_id}/image/sharpness

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "status" : "ok"
}}]
     - parameter body: (body)  
     - parameter cameraId: (path)  

     - returns: RequestBuilder<APIResponseStatusOK> 
     */
    open class func updateCameraImageSharpnessWithRequestBuilder(body: ONVIFCameraImageSettingUpdate, cameraId: UUID) -> RequestBuilder<APIResponseStatusOK> {
        var path = "/api/v1/onvif/{camera_id}/image/sharpness"
        let cameraIdPreEscape = "\(cameraId)"
        let cameraIdPostEscape = cameraIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{camera_id}", with: cameraIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<APIResponseStatusOK>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "PUT", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
    /**
     Update camera image white balance

     - parameter body: (body)  
     - parameter cameraId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func updateCameraImageWhiteBalance(body: ONVIFCameraWhiteBalanceUpdate, cameraId: UUID, completion: @escaping ((_ data: APIResponseStatusOK?,_ error: Error?) -> Void)) {
        updateCameraImageWhiteBalanceWithRequestBuilder(body: body, cameraId: cameraId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Update camera image white balance
     - PUT /api/v1/onvif/{camera_id}/image/wb

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "status" : "ok"
}}]
     - parameter body: (body)  
     - parameter cameraId: (path)  

     - returns: RequestBuilder<APIResponseStatusOK> 
     */
    open class func updateCameraImageWhiteBalanceWithRequestBuilder(body: ONVIFCameraWhiteBalanceUpdate, cameraId: UUID) -> RequestBuilder<APIResponseStatusOK> {
        var path = "/api/v1/onvif/{camera_id}/image/wb"
        let cameraIdPreEscape = "\(cameraId)"
        let cameraIdPostEscape = cameraIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{camera_id}", with: cameraIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<APIResponseStatusOK>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "PUT", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
    /**
     Update camera image wide dynamic range

     - parameter body: (body)  
     - parameter cameraId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func updateCameraImageWideDynamicRange(body: ONVIFCameraWideDynamicRangeUpdate, cameraId: UUID, completion: @escaping ((_ data: APIResponseStatusOK?,_ error: Error?) -> Void)) {
        updateCameraImageWideDynamicRangeWithRequestBuilder(body: body, cameraId: cameraId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Update camera image wide dynamic range
     - PUT /api/v1/onvif/{camera_id}/image/dr

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "status" : "ok"
}}]
     - parameter body: (body)  
     - parameter cameraId: (path)  

     - returns: RequestBuilder<APIResponseStatusOK> 
     */
    open class func updateCameraImageWideDynamicRangeWithRequestBuilder(body: ONVIFCameraWideDynamicRangeUpdate, cameraId: UUID) -> RequestBuilder<APIResponseStatusOK> {
        var path = "/api/v1/onvif/{camera_id}/image/dr"
        let cameraIdPreEscape = "\(cameraId)"
        let cameraIdPostEscape = cameraIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{camera_id}", with: cameraIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<APIResponseStatusOK>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "PUT", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
    /**
     Update camera network settings

     - parameter body: (body)  
     - parameter cameraId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func updateCameraNetworkSettings(body: ONVIFCameraNetworkSettingsUpdate, cameraId: UUID, completion: @escaping ((_ data: APIResponseStatusOK?,_ error: Error?) -> Void)) {
        updateCameraNetworkSettingsWithRequestBuilder(body: body, cameraId: cameraId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Update camera network settings
     - PUT /api/v1/onvif/{camera_id}/network

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "status" : "ok"
}}]
     - parameter body: (body)  
     - parameter cameraId: (path)  

     - returns: RequestBuilder<APIResponseStatusOK> 
     */
    open class func updateCameraNetworkSettingsWithRequestBuilder(body: ONVIFCameraNetworkSettingsUpdate, cameraId: UUID) -> RequestBuilder<APIResponseStatusOK> {
        var path = "/api/v1/onvif/{camera_id}/network"
        let cameraIdPreEscape = "\(cameraId)"
        let cameraIdPostEscape = cameraIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{camera_id}", with: cameraIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<APIResponseStatusOK>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "PUT", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
    /**
     Update camera PTZ

     - parameter body: (body)  
     - parameter cameraId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func updateCameraPtz(body: ONVIFCameraPTZUpdate, cameraId: UUID, completion: @escaping ((_ data: APIResponseStatusOK?,_ error: Error?) -> Void)) {
        updateCameraPtzWithRequestBuilder(body: body, cameraId: cameraId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Update camera PTZ
     - PUT /api/v1/onvif/{camera_id}/ptz

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "status" : "ok"
}}]
     - parameter body: (body)  
     - parameter cameraId: (path)  

     - returns: RequestBuilder<APIResponseStatusOK> 
     */
    open class func updateCameraPtzWithRequestBuilder(body: ONVIFCameraPTZUpdate, cameraId: UUID) -> RequestBuilder<APIResponseStatusOK> {
        var path = "/api/v1/onvif/{camera_id}/ptz"
        let cameraIdPreEscape = "\(cameraId)"
        let cameraIdPostEscape = cameraIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{camera_id}", with: cameraIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<APIResponseStatusOK>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "PUT", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
    /**
     Update camera stream encoder settings

     - parameter body: (body)  
     - parameter cameraId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func updateCameraStreamEncoder(body: ONVIFCameraStreamEncoderUpdate, cameraId: UUID, completion: @escaping ((_ data: APIResponseStatusOK?,_ error: Error?) -> Void)) {
        updateCameraStreamEncoderWithRequestBuilder(body: body, cameraId: cameraId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Update camera stream encoder settings
     - PUT /api/v1/onvif/{camera_id}/stream/encoder

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "status" : "ok"
}}]
     - parameter body: (body)  
     - parameter cameraId: (path)  

     - returns: RequestBuilder<APIResponseStatusOK> 
     */
    open class func updateCameraStreamEncoderWithRequestBuilder(body: ONVIFCameraStreamEncoderUpdate, cameraId: UUID) -> RequestBuilder<APIResponseStatusOK> {
        var path = "/api/v1/onvif/{camera_id}/stream/encoder"
        let cameraIdPreEscape = "\(cameraId)"
        let cameraIdPostEscape = cameraIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{camera_id}", with: cameraIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<APIResponseStatusOK>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "PUT", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
    /**
     Update camera user password

     - parameter body: (body)  
     - parameter cameraId: (path)  
     - parameter username: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func updateCameraUser(body: ONVIFUserPasswordBody, cameraId: UUID, username: String, completion: @escaping ((_ data: APIResponseStatusOK?,_ error: Error?) -> Void)) {
        updateCameraUserWithRequestBuilder(body: body, cameraId: cameraId, username: username).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Update camera user password
     - PUT /api/v1/onvif/{camera_id}/users/{username}

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "status" : "ok"
}}]
     - parameter body: (body)  
     - parameter cameraId: (path)  
     - parameter username: (path)  

     - returns: RequestBuilder<APIResponseStatusOK> 
     */
    open class func updateCameraUserWithRequestBuilder(body: ONVIFUserPasswordBody, cameraId: UUID, username: String) -> RequestBuilder<APIResponseStatusOK> {
        var path = "/api/v1/onvif/{camera_id}/users/{username}"
        let cameraIdPreEscape = "\(cameraId)"
        let cameraIdPostEscape = cameraIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{camera_id}", with: cameraIdPostEscape, options: .literal, range: nil)
        let usernamePreEscape = "\(username)"
        let usernamePostEscape = usernamePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{username}", with: usernamePostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<APIResponseStatusOK>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "PUT", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
}
